#include <bits/stdc++.h>
using namespace std;

const int N = 200001;

vector<int> reversed(vector<int> x)
{
	reverse(x.begin(), x.end());
	return x;
}

vector<int> negated(vector<int> x)
{
	for(auto &y: x)
		y = -y;
	return x;
}

void ans_reverse(vector<string> &s)
{
	for(auto &t: s)
		reverse(t.begin(), t.end());
}

void ans_negate(vector<string> &s)
{
	for(auto &t: s)
	{
		char mx = *max_element(t.begin(), t.end()), mn = *min_element(t.begin(), t.end());
		for(auto &c: t)
			c = mn + (mx - c);
	}
}

void renumber(vector<int> &x)
{
	vector<int> v = x;
	sort(v.begin(), v.end());
	for(auto &y: x)
		y = lower_bound(v.begin(), v.end(), y) - v.begin();
}

vector<string> answers(vector<int> x)
{
	renumber(x);
	int n = x.size();
	vector<int> before(n), after(n);
	
	int before_mx = -1;
	
	priority_queue<int> common;
	multiset<int> after_ms(x.begin(), x.end());
	
	for(auto y: x)
		after[y]++;
	
	vector<string> ans;
	for(auto y: x)
	{
		after[y]--;
		after_ms.erase(after_ms.find(y));
		while(!common.empty() && (!before[common.top()] || !after[common.top()]))
			common.pop();
	
		//111
		if(before[y] && after[y])
			ans.push_back("111");
		//212
		if(!common.empty() && common.top() > y)
			ans.push_back("212");
		//112
		if(before[y] && !after_ms.empty() &&  *after_ms.rbegin() > y)
			ans.push_back("112");
		//321
		if(before_mx > y && !after_ms.empty()  && *after_ms.begin() < y)
			ans.push_back("321");
		//312
		auto it = after_ms.upper_bound(y);
		if(it != after_ms.end() && before_mx > *it)
			ans.push_back("312");
		
		before_mx = max(before_mx, y);
		before[y]++;
		if(before[y] && after[y])
			common.push(y);
	}
	sort(ans.begin(), ans.end());
	ans.erase(unique(ans.begin(), ans.end()), ans.end());
	return ans;
}

int main()
{
	int n;
	scanf("%d", &n);
	vector<int> x(n);
	for(auto &y: x)
		scanf("%d", &y);
	set<string> ans;
	for(int rev: { 0, 1 })
		for(int neg: { 0, 1 })
		{
			vector<int> v = x;
			if(rev) v = reversed(v);
			if(neg) v = negated(v);
			auto vans = answers(v);
			if(rev) ans_reverse(vans);
			if(neg) ans_negate(vans);
			ans.insert(vans.begin(), vans.end());
		}
	for(auto s: ans)
		printf("%s\n", s.c_str());
}
